#!/bin/bash -v

#
#  dirty bash script to compile quantify graph without linking object files via library
#
#  matthias lieber
#

### compiler
#CC="g++ -O3 -static"
#CC="g++ -fopenmp -pthread -O3"  # orig
#CC="g++ -O3"
CC="icpc -I. -fast"
#CC="icpc -I. -O3"
#CC="icpc -I. -O3 -ipo -xHost -no-prec-div"


### disable some of the performance fixes?
#CC="$CC -DNO_BIGCHUNK_FIX -DNO_SYSTEM_FIX -DNO_KMER_COMPARE_FIX"
#CC="$CC -DNO_KMER_COMPARE_FIX"
#CC="$CC -DML_TIMER"


if true ; then
$CC -W -Wall -Wno-unused -Wno-deprecated -ansi -Wno-long-long -Woverloaded-virtual    -DMAKE_DATE='"Mon Apr  9 12:42:47 EDT 2012"' -DMAKE_OS_RELEASE='"2.6.32-220.7.1.el6.x86_64"' -DMAKE_RELEASE='"3.0"' -DNEW_MAKEFILE -imacros system/BigFileDefines.h -ftemplate-depth-30 -fno-strict-aliasing -mieee-fp -iquote . -ISpines      -c ./aligns/KmerAlignCore.cc -o obj/aligns/KmerAlignCore.o
$CC -W -Wall -Wno-unused -Wno-deprecated -ansi -Wno-long-long -Woverloaded-virtual    -DMAKE_DATE='"Mon Apr  9 12:42:51 EDT 2012"' -DMAKE_OS_RELEASE='"2.6.32-220.7.1.el6.x86_64"' -DMAKE_RELEASE='"3.0"' -DNEW_MAKEFILE -imacros system/BigFileDefines.h -ftemplate-depth-30 -fno-strict-aliasing -mieee-fp -iquote . -ISpines      -c ./analysis/AACodons.cc -o obj/analysis/AACodons.o
$CC -W -Wall -Wno-unused -Wno-deprecated -ansi -Wno-long-long -Woverloaded-virtual    -DMAKE_DATE='"Mon Apr  9 12:43:02 EDT 2012"' -DMAKE_OS_RELEASE='"2.6.32-220.7.1.el6.x86_64"' -DMAKE_RELEASE='"3.0"' -DNEW_MAKEFILE -imacros system/BigFileDefines.h -ftemplate-depth-30 -fno-strict-aliasing -mieee-fp -iquote . -ISpines      -c ./analysis/NonRedKmerTable.cc -o obj/analysis/NonRedKmerTable.o
$CC -W -Wall -Wno-unused -Wno-deprecated -ansi -Wno-long-long -Woverloaded-virtual    -DMAKE_DATE='"Mon Apr  9 12:43:06 EDT 2012"' -DMAKE_OS_RELEASE='"2.6.32-220.7.1.el6.x86_64"' -DMAKE_RELEASE='"3.0"' -DNEW_MAKEFILE -imacros system/BigFileDefines.h -ftemplate-depth-30 -fno-strict-aliasing -mieee-fp -iquote . -ISpines      -c ./base/ErrorHandling.cc -o obj/base/ErrorHandling.o
$CC -W -Wall -Wno-unused -Wno-deprecated -ansi -Wno-long-long -Woverloaded-virtual    -DMAKE_DATE='"Mon Apr  9 12:43:06 EDT 2012"' -DMAKE_OS_RELEASE='"2.6.32-220.7.1.el6.x86_64"' -DMAKE_RELEASE='"3.0"' -DNEW_MAKEFILE -imacros system/BigFileDefines.h -ftemplate-depth-30 -fno-strict-aliasing -mieee-fp -iquote . -ISpines      -c ./base/FileParser.cc -o obj/base/FileParser.o
$CC -W -Wall -Wno-unused -Wno-deprecated -ansi -Wno-long-long -Woverloaded-virtual    -DMAKE_DATE='"Mon Apr  9 12:43:07 EDT 2012"' -DMAKE_OS_RELEASE='"2.6.32-220.7.1.el6.x86_64"' -DMAKE_RELEASE='"3.0"' -DNEW_MAKEFILE -imacros system/BigFileDefines.h -ftemplate-depth-30 -fno-strict-aliasing -mieee-fp -iquote . -ISpines      -c ./base/StringUtil.cc -o obj/base/StringUtil.o
$CC -W -Wall -Wno-unused -Wno-deprecated -ansi -Wno-long-long -Woverloaded-virtual    -DMAKE_DATE='"Mon Apr  9 12:43:08 EDT 2012"' -DMAKE_OS_RELEASE='"2.6.32-220.7.1.el6.x86_64"' -DMAKE_RELEASE='"3.0"' -DNEW_MAKEFILE -imacros system/BigFileDefines.h -ftemplate-depth-30 -fno-strict-aliasing -mieee-fp -iquote . -ISpines      -c ./util/mutil.cc -o obj/util/mutil.o
fi

# KmerTable.o
$CC -W -Wall -Wno-unused -Wno-deprecated -ansi -Wno-long-long -Woverloaded-virtual    -DMAKE_DATE='"Mon Apr  9 12:42:59 EDT 2012"' -DMAKE_OS_RELEASE='"2.6.32-220.7.1.el6.x86_64"' -DMAKE_RELEASE='"3.0"' -DNEW_MAKEFILE -imacros system/BigFileDefines.h -ftemplate-depth-30 -fno-strict-aliasing -mieee-fp -iquote . -ISpines      -c ./analysis/KmerTable.cc -o obj/analysis/KmerTable.o

# DNAVector.o
$CC -W -Wall -Wno-unused -Wno-deprecated -ansi -Wno-long-long -Woverloaded-virtual    -DMAKE_DATE='"Mon Apr  9 12:42:55 EDT 2012"' -DMAKE_OS_RELEASE='"2.6.32-220.7.1.el6.x86_64"' -DMAKE_RELEASE='"3.0"' -DNEW_MAKEFILE -imacros system/BigFileDefines.h -ftemplate-depth-30 -fno-strict-aliasing -mieee-fp -iquote . -ISpines      -c ./analysis/DNAVector.cc -o obj/analysis/DNAVector.o

# QuantifyGraph.o 
$CC -W -Wall -Wno-unused -Wno-deprecated -ansi -Wno-long-long -Woverloaded-virtual    -DMAKE_DATE='"Mon Apr  9 12:43:03 EDT 2012"' -DMAKE_OS_RELEASE='"2.6.32-220.7.1.el6.x86_64"' -DMAKE_RELEASE='"3.0"' -DNEW_MAKEFILE -imacros system/BigFileDefines.h -ftemplate-depth-30 -fno-strict-aliasing -mieee-fp -iquote . -ISpines      -c ./analysis/QuantifyGraph.cc -o obj/analysis/QuantifyGraph.o

$CC  -o ./QuantifyGraph  -L. obj/aligns/KmerAlignCore.o obj/analysis/AACodons.o obj/analysis/DNAVector.o obj/analysis/KmerTable.o obj/analysis/NonRedKmerTable.o obj/analysis/QuantifyGraph.o obj/base/ErrorHandling.o obj/base/FileParser.o obj/base/StringUtil.o obj/util/mutil.o

